#!/usr/local/bin/python

##  Copyright (C) 1998  marduk <marduk@starship.skyport.net>

##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.

##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.

##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


__version__ = '0.9'
__author__ = 'marduk (marduk@starship.skyport.net)'

HTTP_STATUS_CODES= {'100':"Continue",
		    '101':"Switching Protocols",
		    '200':"OK",
		    '201':"Created",
		    '202':"Accepted",
		    '204':"No Content",
		    '205':"Reset Content",
		    '206':"Partial Content",
		    '300':"Multiple Choices",
		    '301':"Moved Permanently",
		    '302':"Moved Temporarily",
		    '303':"See Other",
		    '304':"Not Modified",
		    '305':"Use Proxy",
		    '400':"Bad Request",
		    '401':"Unauthorized",
		    '402':"Payment Required",
		    '403':"Forbidden",
		    '404':"Not Found",
		    '405':"Method Not Allowed",
		    '406':"Not Acceptable",
		    '407':"Proxy Authentication Required",
		    '408':"Request Time-out",
		    '409':"Conflict",
		    '410':"Gone",
		    '411':"Length Required",
		    '412':"Precondition Failed",
		    '413':"Request Entity Too Large",
		    '414':"Request-URI Too Large",
		    '415':"Unsupported Media Type",
		    '500':"Internal Server Error",
		    '501':"Not Implemented",
		    '502':"Bad Gateway",
		    '503':"Service Unavailable",
		    '504':"Gateway Time-out",
		    '505':"HTTP Version not supported"
		    }

config = None
robot_parsers={}
SECS_PER_DAY=60*60*24
compiled_ex = []
compiled_yanked = []

from urllib import *
import htmllib
import httplib
import robotparser
import string
import time
import re
import stat

class MyFancyURLopener(FancyURLopener):
    """ i need to override open and open_http to return the error status as 
    well as the file and headers """

    errcode = None

    def __init__(self, proxies=None):
	FancyURLopener.__init__(self, proxies)
	
    def __del__(self):
	FancyURLopener.close(self)

    def open(self,fullurl, data=None):
	self.errcode = None
	return FancyURLopener.open(self,fullurl, data)

    # Use HTTP protocol
    def open_http(self, url, data=None):
	self.url = url
	if type(url) is type(""):
	    host, selector = splithost(url)
	    user_passwd, host = splituser(host)
	    realhost = host
	else:
	    host, selector = url
	    urltype, rest = splittype(selector)
	    user_passwd = None
	    if string.lower(urltype) != 'http':
		realhost = None
	    else:
		realhost, rest = splithost(rest)
		user_passwd, realhost = splituser(realhost)
		if user_passwd:
		    selector = "%s://%s%s" % (urltype,
					      realhost, rest)
	     #print "proxy via http:", host, selector
	if not host: raise IOError, ('http error', 'no host given')
	if user_passwd:
	    import base64
	    auth = string.strip(base64.encodestring(user_passwd))
	else:
	    auth = None
	h = httplib.HTTP(host)
	if data is not None:
	    h.putrequest('POST', selector)
	    h.putheader('Content-type',
			'application/x-www-form-urlencoded')
	    h.putheader('Content-length', '%d' % len(data))
	else:
	    h.putrequest('GET', selector)
	if auth: h.putheader('Authorization', 'Basic %s' % auth)
	if realhost: h.putheader('Host', realhost)
	for args in self.addheaders: apply(h.putheader, args)
	h.endheaders()
	if data is not None:
	    h.send(data + '\r\n')
	errcode, errmsg, headers = h.getreply()
	fp = h.getfile()
	self.errcode = errcode
	if errcode == 200:
	    return addinfourl(fp, headers, "http:" + url)
	else:
	    return self.http_error(url,
				   fp, errcode, errmsg, headers)

############################################################################
class Link:
    """ my class of url's which includes parents, HTTP status number, and
        a list of URL's in that link urls should be passed urlformat()ed
    """

    linkList = {}
    badLinks = []
    notChecked = []
    images = {}
    baseurl = ""
    base=""

    # This is a static variable to indicate if the config.EXCLUDED urls have been
    # compiled as regular expressions.
    re_compiled = 0

    def __init__(self,url,parent):
	self.init()

	#print '\tparent = ' + str(parent)
	opener = MyFancyURLopener(config.PROXIES)
	opener.addheaders = [('User-agent','Linbot ' + __version__)]
	from urlparse import *

	parsed = urlparse(url)
	self.scheme = parsed[0]
	location = parsed[1]

	#elf.URL=url
	#self.URL = urlformat(url,parent)
	#print '\tURL: '+ str(self.URL)
	#Link.linkList[self.URL]=self
	
	if parent not in self.parents:
	    if parent: self.parents.append(parent)
	    
	# we want to ignore url's that are not http, ftp, or file
	if self.scheme not in config.SCHEMES:
	    self.status="Not Checked"
	    self.external=1
	    self.URL=url
	    Link.notChecked.append(self.URL)
	    Link.linkList[self.URL]=self
	    print '\tNot checked: URL scheme ' + self.scheme + ' ignored.'
	    return
	
	if (parent is None):
	    if (location and location not in config.HOSTS): 
		# this is the base host
		config.HOSTS.append(location)
	    for host in config.HOSTS:
		print '\tGetting robots.txt for %s' % location
		rp=robotparser.RobotFileParser(config.PROXIES)
		try:
		    rp.set_url(urlunparse((self.scheme,location,'/robots.txt','','','')))
		    rp.read()
		    robot_parsers[location]=rp
		except:
		    continue

	# see if robots.txt will let us in
	if robot_parsers.has_key(location):
	    if not robot_parsers[location].can_fetch('Linbot',url):
		print '\tRobot Restricted'
		self.status='Not Checked'
		Link.notChecked.append(url)
		#self.external=1
		return

	# open url
	try:
	    tmpFileName, self.headers = opener.retrieve(basejoin(parent,url))
	    #tmpFileName, self.headers = opener.retrieve(urlformat(url,parent))
	except IOError, data:
	    self.set_bad_link(url,str(data.errno) + ': ' + str(data.strerror))
	    return
	except:
	    self.set_bad_link(url,"Unknown error: Bad URL?")
	    return
	    
	htmlfile = open(tmpFileName,'r')

	if (self.scheme == 'http'):
	    self.URL = 'http:' + opener.url
	    Link.linkList[self.URL]=self
	else:
	    self.URL = url

	self.size = getSize(tmpFileName)
	# If I uncomment the next line, it will create duplicates.
	#Link.linkList[url]=self

	if parent is None:
	    Link.baseurl=self.URL
	    Link.base=self.URL[:string.rfind(self.URL,'/')+1]
	    if Link.base[-2:] == '//': Link.base = self.URL
	    print '\tbase: %s' % Link.base
	    parse_base = urlparse(Link.base)
	    base_location = parse_base[1]
	    if base_location not in config.HOSTS:
		# this is a redirected base host
		config.HOSTS.append(base_location)

	# if could get httpfile:
	self.status = opener.errcode

	
	if (self.scheme=='http'):
	    if not hasattr(self.headers,'getheader'):
		print '\tDocument contains no data'
		self.URL=url
		Link.linkList[self.URL]=self
		Link.badLinks.append(self.URL)
		return
	    if (str(self.headers.getheader("Content-Type"))[:9] == "text/html"):
		if self.status==200:
		    self._handleHTML(self.URL,htmlfile)
		else:
		    print '\tBad Link'
		    self.URL=url
		    Link.linkList[self.URL]=self
		    Link.badLinks.append(self.URL)
	elif self.scheme in ['file','ftp']:
	    # find out if this is an html file
	    if isHTML(self.URL):
		self._handleHTML(self.URL,htmlfile)
	else: 
	    return
	    
	if self.external:
	    return
	# add me to the linklist, if needed
	for child in self.children:
	    if not Link.linkList.has_key(child):
		if config.WAIT_BETWEEN_REQUESTS > 0:
		    print 'sleeping %s seconds' %  config.WAIT_BETWEEN_REQUESTS
		    time.sleep(config.WAIT_BETWEEN_REQUESTS)
		print "adding url: %s" % child
		if is_external(child) or is_excluded(child):
		    Link.linkList[child]=ExternalLink(child,self.URL)
		elif is_yanked(child):
		    Link.linkList[child]=ExternalLink(child,self.URL,1)
		else:
		    Link.linkList[child]=Link(child,self.URL)
	    elif self.URL not in Link.linkList[child].parents:
		Link.linkList[child].parents.append(self.URL)
	return # __init__

    def init(self):
	""" initialize some variables """
	self.age = None
	self.scheme = None
	self.headers = None
	self.parents= []
	self.children = []
	self.status = None
	self.title = None
	self.external = 0
	self.html = 0
	self.size = 0
	self.totalSize = 0
	self.author = None

    def __repr__(self):
	return self.URL

    def set_bad_link(self,url,status):
	""" flags the link as bad """
	print '\t' + str(status)
	self.status = str(status)
	self.URL=url
	Link.linkList[self.URL]=self
	Link.badLinks.append(self.URL)

    def _handleHTML(self,url,htmlfile):
	"""examines and html file and updates the Link object"""
	# get anchorlist
	(anchorlist, imagelist, title, author) = pageLinks(url,htmlfile)
	
	print '\ttitle: %s' % str(title)
	for child in anchorlist:
	    if child not in self.children:
		self.children.append(child)
		    
	self.age = getAge(self)
	self.totalSize = self.size
	self.title = title
	self.author = author
	self.html = 1
	# get image list
	for image in imagelist:
	    if image not in Link.images.keys():
		print 'adding image: %s' % image
		Link.images[image] = Image(image, self.URL)
	    self.totalSize = self.totalSize + int(Link.images[image].size)
	return



class ExternalLink(Link):
    """ this class is just like Link, but it does not explore it's children """
    
    def __init__(self,url,parent,yanked=0):

	if config.AVOID_EXTERNAL_LINKS or yanked:
	    self.init()
	    self.status="Not Checked"
	    self.external=1
	    print '\tNot checked'
	    if yanked: print '\tYanked'
	    if parent not in self.parents:
		if parent: self.parents.append(parent)
	    Link.notChecked.append(url)
	    return
	Link.__init__(self,url,parent)
	self.external=1


    def _handleHTML(self,url,htmlfile):
	# ignore links and images, but use the title
	self.title = pageLinks(url,htmlfile)[2]
	print '\ttitle: %s' % str(self.title)
	self.children=[]
	self.age = getAge(self)

class Image(Link):
    """ This class is just like link, but different :-)"""
    def __init__(self, url, parent):
	self.init()
	Link.__init__(self, url, parent)
	#self.age = getAge(self)

    def _handleHTML(self,url,htmlfile):
	"""Don't handle HTML, this is an image"""
	self.set_bad_link(url,"HTML file used in IMG tag?")
	return

def is_external(url):
    """ returns true if url is an external link """
    from urlparse import *
    parsed = urlparse(url)
    scheme = parsed[0]
    location = parsed[1]
    if (location not in config.HOSTS) and (scheme in ['http','ftp']):
	return 1
    if config.BASE_URLS_ONLY and (Link.base!=url[:len(Link.base)]):
	return 1
    return 0

def compile_re():
    """Compile EXCLUDED URLSs and set flag"""
    global compiled_ex
    for i in config.EXCLUDED_URLS:
	compiled_ex.append(re.compile(i,re.IGNORECASE))
    for i in config.YANKED_URLS:
	compiled_yanked.append(re.compile(i,re.IGNORECASE))
    Link.re_compiled = 1

def is_excluded(url):
    """ Returns true if url is part of the EXCLUDED_URLS list """
    if not Link.re_compiled:
	compile_re()
    for x in compiled_ex:
	if x.search(url) is not None:
	    return 1
    return 0

def is_yanked(url):
    """ Returns true if url is part of YANKED_URLS list"""
    if not Link.re_compiled:
	compile_re()
    for x in compiled_yanked:
	if x.search(url) is not None:
	    return 1
    return 0


############################################################################    
# myHTMLParser class is derived from htmllib.HTMLParse but to handle images#
# authors, etc.                                                            #
############################################################################
class MyHTMLParser(htmllib.HTMLParser):
    
    def __init__(self,formatter):
	self.imagelist = []
	self.title = None
	self.author = None
	self.base = None
	htmllib.HTMLParser.__init__(self,formatter)
	
    # override handle_image() 
    def handle_image(self,src,alt,*stuff):
	if src not in self.imagelist: self.imagelist.append(src)

    def do_frame(self,attrs):
	for name, val in attrs:
	    if name=="src":
		self.anchorlist.append(val)

    def save_bgn(self):
	self.savedata = ''
	

    def save_end(self):
	data = self.savedata
	self.savedata = None
	return data

    def start_title(self, attrs):
	self.save_bgn()

    def end_title(self):
	if not self.savedata:
	    self.title = None
	    return
	self.title = string.join(string.split(self.save_end()))

    def do_meta(self,attrs):
	fields={}
	for name, value in attrs:
	    fields[name]=value
	if fields.has_key('name'):
	    if string.lower(fields['name']) == 'author':
		if fields.has_key('content'):
		    author = fields['content']
		    self.author = author
		    print '\tauthor: ' + author

    # <AREA> for client-side image maps
    def do_area(self,attrs):
	for name, val in attrs:
	    if name=="href":
		if val not in self.anchorlist:
		    self.anchorlist.append(val)

    def do_base(self,attrs):
	for name,val in attrs:
	    if name=="href":
		self.base = val

def pageLinks(url,page):
    """ returns a list of all the url's in a page.  page should be a file object
    Partial urls will be expanded using <url> parameter unless the page contains
    the <BASE HREF=> tag."""
    import htmllib
    from urlparse import *
    from formatter import NullFormatter

    parser = MyHTMLParser(NullFormatter())
    parser.feed(page.read())
    urllist = []
    imagelist = []
	
    title = parser.title
    author = parser.author
    if parser.base is not None:
	parent = parser.base
    else:
	parent = url
    for anchor in parser.anchorlist:
	anchor=urlformat(anchor,parent)
	if anchor not in urllist: urllist.append(anchor)
	
	for image in parser.imagelist:
	    image=urlformat(image,parent)
	    if image not in imagelist: imagelist.append(image)
		
    return (urllist, imagelist, title, author)


def urlformat(url,parent=None):
    """ returns a formatted version of URL, which, adds trailing '/'s, if 
    necessary, deletes fragmentation identifiers '#' and expands partial url's 
    based on parent"""
    
    from urlparse import *
    
    method=urlparse(url)[0]
    if (method=='') and (parent != None):
	url=urljoin(parent,url)
	#url=basejoin(parent,url)
    parsedlist = list(urlparse(url))
    parsedlist[5]='' # remove fragment
    # parsedlist[4]='' # remove query string
    url = urlunparse(tuple(parsedlist))
    return url
    

def isHTML(filename):
    """ returns true if filename reflects and html file.  Note this is not an
    exact science"""
    
    extensions = ['html','htm','shtml','shtm','stm'] # asp ?
    
    extension=filename[string.rfind(filename,'.')+1:len(filename)]
    return (extension in extensions)
    
def getAge(link):
    # get age of link
    if link.scheme=='http':
	try:
	    lastMod = time.mktime(link.headers.getdate('Last-Modified'))
	except (OverflowError, TypeError, ValueError):
	    lastMod = None
	if lastMod:
	    age = int((time.time()-lastMod)/SECS_PER_DAY)
	else:
	    age = None
	return age
    elif link.scheme=='file':
	from urlparse import urlparse
	path = urlparse(link.URL)[2]
	lastMod = os.stat(path)[stat.ST_MTIME]
	age = int((time.time()-lastMod)/SECS_PER_DAY)
	return age

def getSize(filename):
    """Not that size matters, but..."""
    from urlparse import urlparse
    size = int(os.stat(filename)[stat.ST_SIZE]) # will I get screwed with block
    return int(size)
